<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    <boolean-icon :is-checked="value" />
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <switch-with-label-field
          :value="value"
          :hint="$t('hint')"
          persistent-hint
          @input="emitValueToParent"
        >
          {{ $t('isPaymentConfirmed') }} {{ answer }}
        </switch-with-label-field>
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  export default {
    name: 'EditIsPaymentConfirmedDialog',
    inheritAttrs: false,
    props: {
      value: Number,
      itemId: {
        type: Number,
        required: true,
      },
    },
    computed: {
      answer () {
        return this.value
          ? this.$t('yes')
          : this.$t('no')
      },
    },
    methods: {
      onSave (isPaymentConfirmed) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('incomeAmounts/updateIncomeAmountIsPaymentConfirmed', {
            ID: this.itemId,
            isPaymentConfirmed,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateSuccess: 'Confirmação de pagamento atualizada com sucesso!',
          isPaymentConfirmed: 'O pagamento está confirmado?',
          yes: 'Sim.',
          no: 'Não.',
          hint: 'Dica: apenas os pagamentos confirmados são utilizados nos cálculos.',
        },
        'en-US': {
          updateSuccess: 'Payment confirmation successfully updated!',
          isPaymentConfirmed: 'Is payment confirmed?',
          yes: 'Yes.',
          no: 'No.',
          hint: 'Tip: only confirmed payments are used in calculations.',
        },
      },
    },
  }
</script>
